Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file netcdf_interface_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,11 @@
 ! -----------------
 ! $Id$
+! Implementation of uv exposure model (FK)
+! Implemented checks for turbulence_closure_mod (TG)
+! Implementation of chemistry module (FK)
+! Bugfix in setting netcdf grids for LSM variables
+! Enable setting of _FillValue attribute in output files (MS)
+!
+! 2512 2017-10-04 08:26:59Z raasch
 ! upper bounds of cross section and 3d output changed from nx+1,ny+1 to nx,ny
 ! no output of ghost layer data any more
@@ -410,9 +417,12 @@
     INTEGER(iwp), DIMENSION(1:max_masks,0:1,100) ::  id_var_domask
 
+    REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
 
     PUBLIC  dofl_dim_label_x, dofl_dim_label_y, dofl_dim_label_z, dofl_label,  &
             dofl_time_count, dofl_unit, domask_unit, dopr_unit, dopts_num,     &
             dots_label, dots_max, dots_num, dots_rad, dots_soil, dots_unit,    &
-            do2d_unit, do3d_unit, id_set_fl, id_set_mask, id_set_pr,           &
+            do2d_unit, do3d_unit, fill_value,                                  & 
+            id_set_fl, id_set_mask, id_set_pr,                                 &
             id_set_prt, id_set_pts, id_set_sp, id_set_ts, id_set_xy, id_set_xz,&
             id_set_yz, id_set_3d, id_var_domask, id_var_dofl, id_var_dopr,     &
@@ -432,8 +442,4 @@
     END INTERFACE netcdf_create_dim
 
-    INTERFACE netcdf_close_file
-       MODULE PROCEDURE netcdf_close_file
-    END INTERFACE netcdf_close_file
-
     INTERFACE netcdf_create_file
        MODULE PROCEDURE netcdf_create_file
@@ -448,28 +454,14 @@
     END INTERFACE netcdf_define_header
 
-    INTERFACE netcdf_get_attribute
-       MODULE PROCEDURE netcdf_get_attribute
-    END INTERFACE netcdf_get_attribute
-
-    INTERFACE netcdf_get_variable
-       MODULE PROCEDURE netcdf_get_variable_2d
-       MODULE PROCEDURE netcdf_get_variable_3d
-    END INTERFACE netcdf_get_variable
-
     INTERFACE netcdf_handle_error
        MODULE PROCEDURE netcdf_handle_error
     END INTERFACE netcdf_handle_error
 
-    INTERFACE netcdf_open_read_file
-       MODULE PROCEDURE netcdf_open_read_file
-    END INTERFACE netcdf_open_read_file
-
     INTERFACE netcdf_open_write_file
        MODULE PROCEDURE netcdf_open_write_file
     END INTERFACE netcdf_open_write_file
 
-    PUBLIC netcdf_create_file, netcdf_close_file, netcdf_define_header,        &
-           netcdf_handle_error, netcdf_get_attribute, netcdf_get_variable,     &
-           netcdf_open_read_file, netcdf_open_write_file
+    PUBLIC netcdf_create_file, netcdf_define_header,                           &
+           netcdf_handle_error, netcdf_open_write_file
 
  CONTAINS
@@ -482,9 +474,14 @@
         ONLY:  zu, zw
 
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_define_netcdf_grid 
+#endif
+
     USE constants,                                                             &
         ONLY:  pi
 
     USE control_parameters,                                                    &
-        ONLY:  averaging_interval, averaging_interval_pr,                      &
+        ONLY:  air_chemistry, averaging_interval, averaging_interval_pr,       &
                data_output_pr, domask, dopr_n,                                 &
                dopr_time_count, dopts_time_count, dots_time_count,             &
@@ -493,5 +490,5 @@
                dt_do2d_yz, dt_do3d, mask_size, do2d_xy_time_count,             &
                do3d_time_count, domask_time_count, end_time, land_surface,     &
-               lod, mask_size_l, mask_i, mask_i_global, mask_j, mask_j_global, &
+               mask_size_l, mask_i, mask_i_global, mask_j, mask_j_global,      &
                mask_k_global, message_string, mid, ntdim_2d_xy,                &
                ntdim_2d_xz, ntdim_2d_yz, ntdim_3d, nz_do3d, prt_time_count,    &
@@ -500,5 +497,5 @@
                skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,        &
                skip_time_do3d, topography, num_leg, num_var_fl,                &
-               urban_surface
+               urban_surface, uv_exposure
 
     USE grid_variables,                                                        &
@@ -533,6 +530,12 @@
         ONLY:  hom, statistic_regions
 
+    USE turbulence_closure_mod,                                                &
+        ONLY:  tcm_define_netcdf_grid
+
     USE urban_surface_mod,                                                     &
         ONLY:  usm_define_netcdf_grid
+
+    USE uv_exposure_model_mod,                                                 &
+        ONLY:  uvem_define_netcdf_grid
 
 
@@ -894,4 +897,7 @@
                 CASE DEFAULT
 
+                   CALL tcm_define_netcdf_grid( domask(mid,av,i), found, &
+                                                        grid_x, grid_y, grid_z )
+
 !
 !--                Check for land surface quantities
@@ -900,8 +906,7 @@
                                                    grid_x, grid_y, grid_z )
                    ENDIF
-                   
 !
 !--                Check for plant canopy quantities
-                   IF ( plant_canopy )  THEN
+                   IF ( .NOT. found  .AND.  plant_canopy )  THEN
                       CALL pcm_define_netcdf_grid( domask(mid,av,i), found,    &
                                                    grid_x, grid_y, grid_z )
@@ -915,4 +920,14 @@
                                                          grid_z )
                    ENDIF
+
+!
+!--                Check for chemistry quantities                   
+#if defined( __chem )
+                   IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                      CALL chem_define_netcdf_grid( domask(mid,av,i),          &
+                                                    found, grid_x, grid_y,     &
+                                                    grid_z )
+                   ENDIF
+#endif
 
 !
@@ -961,5 +976,5 @@
                                      id_var_domask(mid,av,i),                  &
                                      TRIM( domask_unit(mid,av,i) ),            &
-                                     domask(mid,av,i), 494, 495, 496 )
+                                     domask(mid,av,i), 494, 495, 496, .TRUE. )
 
              var_list = TRIM( var_list ) // TRIM( domask(mid,av,i) ) // ';'
@@ -1425,4 +1440,7 @@
                 CASE DEFAULT
 
+                   CALL tcm_define_netcdf_grid( do3d(av,i), found, &
+                                                   grid_x, grid_y, grid_z )
+
 !
 !--                Check for land surface quantities
@@ -1434,5 +1452,5 @@
 !
 !--                Check for plant canopy quantities
-                   IF ( plant_canopy )  THEN
+                   IF ( .NOT. found  .AND.  plant_canopy )  THEN
                       CALL pcm_define_netcdf_grid( do3d(av,i), found, grid_x,  &
                                                    grid_y, grid_z )
@@ -1446,5 +1464,14 @@
                                                          grid_z )
                    ENDIF
-                   
+
+!
+!--                Check for chemistry quantities                   
+#if defined( __chem )
+                   IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                      CALL chem_define_netcdf_grid( do3d(av,i), found,         &
+                                                    grid_x, grid_y, grid_z )
+                   ENDIF
+#endif
+
 !--                Check for user-defined quantities
                    IF ( .NOT. found )  THEN
@@ -1490,5 +1517,5 @@
                                      nc_precision(4), id_var_do3d(av,i),       &
                                      TRIM( do3d_unit(av,i) ), do3d(av,i), 79,  &
-                                     80, 357 )
+                                     80, 357, .TRUE. )
 #if defined( __netcdf4_parallel )
              IF ( netcdf_data_format > 4 )  THEN
@@ -2029,5 +2056,5 @@
                                            nc_precision(1), id_var_do2d(av,i), &
                                            TRIM( do2d_unit(av,i) ),            &
-                                           do2d(av,i), 119, 120, 354 )
+                                           do2d(av,i), 119, 120, 354, .TRUE. )
 
                 ELSE
@@ -2079,4 +2106,10 @@
                          ENDIF
 
+                         IF ( .NOT. found )  THEN
+                            CALL tcm_define_netcdf_grid( do2d(av,i), found,    &
+                                                         grid_x, grid_y,       &
+                                                         grid_z )
+                         ENDIF
+
 !
 !--                      Check for radiation quantities
@@ -2085,4 +2118,21 @@
                                                          found, grid_x, grid_y,&
                                                          grid_z )
+                         ENDIF
+
+!
+!--                      Check for chemistry quantities
+#if defined( __chem )
+                         IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                            CALL chem_define_netcdf_grid( do2d(av,i), found,   &
+                                                          grid_x, grid_y,      &
+                                                          grid_z )
+                         ENDIF
+#endif
+
+!
+!--                      Check for UV exposure quantities
+                         IF ( .NOT. found  .AND.  uv_exposure )  THEN
+                            CALL uvem_define_netcdf_grid( do2d(av,i), found,    &
+                                                          grid_x, grid_y, grid_z )
                          ENDIF
 
@@ -2132,5 +2182,5 @@
                                            nc_precision(1), id_var_do2d(av,i), &
                                            TRIM( do2d_unit(av,i) ),            &
-                                           do2d(av,i), 119, 120, 354 )
+                                           do2d(av,i), 119, 120, 354, .TRUE. )
 
                 ENDIF
@@ -2777,4 +2827,9 @@
                       ENDIF
 
+                      IF ( .NOT. found )  THEN
+                         CALL tcm_define_netcdf_grid( do2d(av,i), found,       &
+                                                      grid_x, grid_y, grid_z )
+                      ENDIF
+
 !
 !--                   Check for radiation quantities
@@ -2784,4 +2839,14 @@
                                                             grid_z )
                       ENDIF
+
+!
+!--                   Check for chemistry quantities
+#if defined( __chem )
+                      IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                         CALL chem_define_netcdf_grid( do2d(av,i), found,      &
+                                                       grid_x, grid_y,         &
+                                                       grid_z )
+                      ENDIF
+#endif
 
 !
@@ -2829,5 +2894,5 @@
                                         nc_precision(2), id_var_do2d(av,i),    &
                                         TRIM( do2d_unit(av,i) ), do2d(av,i),   &
-                                        159, 160, 355 )
+                                        159, 160, 355, .TRUE. )
 
 #if defined( __netcdf4_parallel )
@@ -3431,4 +3496,9 @@
                       ENDIF
 
+                      IF ( .NOT. found )  THEN
+                         CALL tcm_define_netcdf_grid( do2d(av,i), found,       &
+                                                      grid_x, grid_y, grid_z )
+                      ENDIF
+
 !
 !--                   Check for radiation quantities
@@ -3439,4 +3509,13 @@
                       ENDIF
 
+!
+!--                   Check for chemistry quantities
+#if defined( __chem )
+                      IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                         CALL chem_define_netcdf_grid( do2d(av,i), found,      &
+                                                       grid_x, grid_y,         &
+                                                       grid_z )
+                      ENDIF
+#endif
 !
 !--                   Check for user-defined quantities
@@ -3483,5 +3562,5 @@
                                         nc_precision(3), id_var_do2d(av,i),    &
                                         TRIM( do2d_unit(av,i) ), do2d(av,i),   &
-                                        198, 199, 356 )
+                                        198, 199, 356, .TRUE. )
 
 #if defined( __netcdf4_parallel )
@@ -5453,174 +5532,4 @@
  END SUBROUTINE netcdf_create_file
 
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Closes an existing netCDF file.
-!------------------------------------------------------------------------------!
- 
- SUBROUTINE netcdf_close_file( id, errno )
-#if defined( __netcdf )
-
-    USE pegrid
-
-    IMPLICIT NONE
-
-    INTEGER(iwp), INTENT(IN)           ::  errno     !< error number
-    INTEGER(iwp), INTENT(INOUT)        ::  id        !< file id
-
-    nc_stat = NF90_CLOSE( id )
-    CALL netcdf_handle_error( 'netcdf_close', errno )
-#endif
- END SUBROUTINE netcdf_close_file
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Opens an existing netCDF file for reading only and gives back the id.
-!------------------------------------------------------------------------------!
- 
- SUBROUTINE netcdf_open_read_file( filename, id, errno )
-#if defined( __netcdf )
-
-    USE pegrid
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*), INTENT(IN) ::  filename  !< filename
-    INTEGER(iwp), INTENT(IN)      ::  errno     !< error number
-    INTEGER(iwp), INTENT(INOUT)   ::  id        !< file id
-    LOGICAL                       ::  file_open = .FALSE.
-
-    nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
-
-    CALL netcdf_handle_error( 'netcdf_open_read_file', errno )
-
-#endif
- END SUBROUTINE netcdf_open_read_file
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Reads the global attributes of a file
-!------------------------------------------------------------------------------!
- 
- SUBROUTINE netcdf_get_attribute( id, attribute_name, value, global, errno, variable_name )
-#if defined( __netcdf )
-
-    USE pegrid
-
-    IMPLICIT NONE
-
-    CHARACTER(LEN=*)            ::  attribute_name   !< attribute name
-    CHARACTER(LEN=*), OPTIONAL  ::  variable_name    !< variable name 
-
-    INTEGER(iwp), INTENT(IN)    ::  errno            !< error number
-    INTEGER(iwp), INTENT(INOUT) ::  id               !< file id
-    INTEGER(iwp), INTENT(INOUT) ::  value            !< read value
-
-    INTEGER(iwp)                ::  id_var           !< variable id
-
-    LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attributes
-
-!
-!-- Read global attribute
-    IF ( global )  THEN
-       nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-       CALL netcdf_handle_error( 'netcdf_get_attribute global', errno )
-!
-!-- Read attributes referring to a single variable. Therefore, first inquire 
-!-- variable id
-    ELSE
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-       CALL netcdf_handle_error( 'netcdf_get_attribute', errno )
-       nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-       CALL netcdf_handle_error( 'netcdf_get_attribute', errno )       
-    ENDIF
-#endif
- END SUBROUTINE netcdf_get_attribute
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Reads a 2D REAL variable of a file. Reading is done processor-wise, 
-!> i.e. each core reads its own domain, as well as in slices along x. 
-!------------------------------------------------------------------------------!
- 
- SUBROUTINE netcdf_get_variable_2d( id, variable_name, i, var, errno )
-#if defined( __netcdf )
-
-    USE indices
-    USE pegrid
-
-    IMPLICIT NONE
-
-    CHARACTER(LEN=*)              ::  variable_name   !< attribute name
-    INTEGER(iwp), INTENT(IN)      ::  errno           !< error number
-    INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
-
-    INTEGER(iwp), INTENT(INOUT)   ::  id              !< file id
-
-    INTEGER(iwp)                  ::  id_var          !< variable id
-
-    REAL(wp), DIMENSION(nys:nyn), INTENT(INOUT) ::  var  !< variable to be read
-    REAL(wp) :: var_dum
-!
-!-- Inquire variable id
-    nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-!
-!-- Get variable
-    nc_stat = NF90_GET_VAR( id, id_var, var(nys:nyn),                        &
-                            start = (/ i+1, nys+1 /),                          &
-                            count = (/ 1, nyn - nys + 1 /) )
-
-    CALL netcdf_handle_error( 'netcdf_get_variable', errno )
-#endif
- END SUBROUTINE netcdf_get_variable_2d
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Reads a 3D INTEGER variable of a file. Reading is done processor-wise, 
-!> i.e. each core reads its own domain, as well as in slices along x. 
-!------------------------------------------------------------------------------!
- 
- SUBROUTINE netcdf_get_variable_3d( id, variable_name, i, j, var, errno )
-#if defined( __netcdf )
-
-    USE indices
-    USE pegrid
-
-    IMPLICIT NONE
-
-    CHARACTER(LEN=*)              ::  variable_name   !< attribute name
-    INTEGER(iwp), INTENT(IN)      ::  errno           !< error number
-    INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
-    INTEGER(iwp), INTENT(IN)      ::  j               !< index along y direction
-
-    INTEGER(iwp), INTENT(INOUT)   ::  id              !< file id
-
-    INTEGER(iwp)                  ::  id_var          !< variable id
-    INTEGER(iwp)                  ::  id_z            !< id of z-dimension
-    INTEGER(iwp)                  ::  nz_file         !< number of grid-points in file
-
-    INTEGER( KIND = 1 ), DIMENSION(nzb:nzt+1), INTENT(INOUT) ::  var  !< variable to be read
-!
-!-- Get dimension of z-axis
-    nc_stat = NF90_INQ_DIMID( id, "z", id_z )
-    nc_stat = NF90_INQUIRE_DIMENSION( id, id_z, len = nz_file )
-!
-!-- Inquire variable id
-    nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-!
-!-- Get variable
-    nc_stat = NF90_GET_VAR( id, id_var, var(0:nz_file-1),                  &
-                            start = (/ i+1, j+1, 1 /),                         &
-                            count = (/ 1, 1, nz_file /) )
-
-    CALL netcdf_handle_error( 'netcdf_get_variable', errno )
-#endif
- END SUBROUTINE netcdf_get_variable_3d
-
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5629,5 +5538,4 @@
 !> The parallel flag has to be TRUE for parallel netCDF output support.
 !------------------------------------------------------------------------------!
- 
  SUBROUTINE netcdf_open_write_file( filename, id, parallel, errno )
 #if defined( __netcdf )
@@ -5731,5 +5639,5 @@
  SUBROUTINE netcdf_create_var( ncid, dim_id, var_name, var_type, var_id,       &
                                unit_name, long_name, error_no1, error_no2,     &
-                               error_no3 )
+                               error_no3, fill )
 
 #if defined( __netcdf )
@@ -5739,4 +5647,6 @@
     CHARACTER(LEN=*), INTENT(IN) ::  unit_name
     CHARACTER(LEN=*), INTENT(IN) ::  var_name
+
+    LOGICAL, OPTIONAL ::  fill  !< indicates setting of _FillValue attribute 
 
     INTEGER, INTENT(IN)  ::  error_no1
@@ -5777,4 +5687,19 @@
     ENDIF
 
+!
+!-- Set _FillValue for all variables, except for dimension variables.
+!-- Set the fill values accordingly to the corresponding output precision. 
+    IF ( PRESENT( fill ) )  THEN
+       IF ( var_type == NF90_REAL4 )  THEN
+          nc_stat = NF90_PUT_ATT( ncid, var_id, '_FillValue',                  &
+                                  REAL( fill_value, KIND = 4 ) )
+          CALL netcdf_handle_error( 'netcdf_create_var', 0 )
+       ELSE
+          nc_stat = NF90_PUT_ATT( ncid, var_id, '_FillValue',                  &
+                                  REAL( fill_value, KIND = 8 ) )
+          CALL netcdf_handle_error( 'netcdf_create_var', 0 )
+       ENDIF
+    ENDIF
+
 #endif
  END SUBROUTINE netcdf_create_var
Index: palm/trunk/SOURCE/outflow_turbulence.f90
===================================================================
--- palm/trunk/SOURCE/outflow_turbulence.f90	(revision 2693)
+++ palm/trunk/SOURCE/outflow_turbulence.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file outflow_turbulence.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 2693)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file package_parin.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 2693)
+++ palm/trunk/SOURCE/palm.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file palm.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! Implementation of chemistry module (FK)
+! Introduce input-data standard
+! Rename lsm_last_actions into lsm_write_restart_data
+! Move usm_write_restart_data into io_blocks loop (MS)
+! 
+! 2512 2017-10-04 08:26:59Z raasch
 ! user interface required revision updated
 ! 
@@ -185,4 +191,5 @@
 !> @todo create routine last_actions instead of calling lsm_last_actions etc.
 !> @todo eventually move CALL usm_write_restart_data to suitable location
+!> @todo move chem_init call to init_3d_model or to check_parameters
 !------------------------------------------------------------------------------!
  PROGRAM palm
@@ -191,6 +198,14 @@
     USE arrays_3d
 
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_init, chem_last_actions
+    USE chem_photolysis_mod,                                                   &
+        ONLY:  photolysis_init
+#endif
+
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, constant_diffusion, coupling_char, coupling_mode,&
+        ONLY:  air_chemistry,                                                  &
+               cloud_physics, constant_diffusion, coupling_char, coupling_mode,&
                do2d_at_begin, do3d_at_begin, humidity, initializing_actions,   &
                io_blocks, io_group, land_surface, large_scale_forcing,         &
@@ -208,8 +223,12 @@
         ONLY:  nbgp
 
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  netcdf_data_input_inquire_file, netcdf_data_input_init,         &
+               netcdf_data_input_surface_data, netcdf_data_input_topo
+
     USE kinds
 
     USE land_surface_model_mod,                                                &
-        ONLY:  lsm_last_actions
+        ONLY:  lsm_write_restart_data
 
     USE particle_attributes,                                                   &
@@ -326,9 +345,34 @@
 !-- Determine processor topology and local array indices
     CALL init_pegrid
-
-!
-!-- Generate grid parameters
+!
+!-- Check if input file according to input-data standard exists
+    CALL netcdf_data_input_inquire_file
+!
+!-- Read topography input data if required. This is required before the 
+!-- numerical grid is finally created in init_grid
+    CALL netcdf_data_input_topo  
+!
+!-- Generate grid parameters, initialize generic topography and further process
+!-- topography information if required
     CALL init_grid
-
+!
+!-- Read global attributes if available.  
+    CALL netcdf_data_input_init 
+!
+!-- Read surface classification data, e.g. vegetation and soil types, water 
+!-- surfaces, etc., if available. Some of these data is required before 
+!-- check parameters is invoked.     
+    CALL netcdf_data_input_surface_data
+!
+!-- Initialize chemistry (called before check_parameters due to dependencies)
+!-- --> Needs to be moved!! What is the dependency about?
+#if defined( __chem )
+! IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+    IF ( air_chemistry )  THEN
+       CALL chem_init
+       CALL photolysis_init   ! probably also required for restart
+    ENDIF
+! END IF
+#endif
 !
 !-- Check control parameters and deduce further quantities
@@ -443,7 +487,4 @@
 !--    If required, write particle data
        IF ( particle_advection )  CALL lpm_write_restart_file
-!
-!--    If required, write urban surface data
-       IF (urban_surface)  CALL usm_write_restart_data
        
     ENDIF
@@ -460,10 +501,20 @@
     DO  i = 0, io_blocks-1
        IF ( i == io_group )  THEN
+
+          IF ( urban_surface )  THEN
+             CALL usm_write_restart_data
+          ENDIF
           IF ( land_surface )  THEN
-             CALL lsm_last_actions
+             CALL lsm_write_restart_data
           ENDIF
           IF ( radiation )  THEN
              CALL radiation_last_actions
           ENDIF
+#if defined( __chem )
+          IF ( air_chemistry )  THEN
+             CALL chem_last_actions
+          ENDIF
+#endif
+          
           CALL user_last_actions
           IF ( write_binary )  CALL close_file( 14 )
